//! # Wooly Vault
//!
//! Wooly Vault is a set of smaller challenges for Rust hackers.
//!
//! A host may choose to open a challenge, set a secret and ask a contestant to try and solve the
//! challenge to get the secret. The contestant can then prove with the secret to the host that
//! they absolved the challenge.
//!
//! Wooly Vault has multiple challenges, and only one can be hosted per instance of this
//! application. The challenges all bind to a pre-set [Network Adress](crate::config::Config::addr).
//! The contestants can then connect to that adress with TCP. The first few challenges use raw TCP,
//! but some of the later ones are small HTTP webservices.
//!
//! Wooly Vault is programmed asynchronously with [tokio] to be able to handle many contestants at
//! once if needed.

pub mod challenge;
pub mod config;
pub mod vault;

#[inline]
pub(crate) fn has_won(addr: &std::net::SocketAddr) {
    libpt::log::info!("Sending the secret to {addr}")
}
